/*************************************************************************
 *
 *			Classe Client : FTP mode connecte
 *
 *			Implementation
 *
 * fichier Client_FTP.C
 *************************************************************************/

#include "Client_FTP.h"
#include "fichier.h"

#define PORT 6002

Client::Client(const char* hostname, int port) {
  // Recuperation du pointeur sur structure hostent du serveur */
  if ((hp=gethostbyname(hostname))==NULL) {
    perror(" nom de machine inconnu");
    exit(2);
  };

  // creation de la socket client
  sock=socket(AF_INET,SOCK_STREAM,0);

  //  initialisation de la structure adress
  bzero((char * )&adress,sizeof(adress));
  adress.sin_port =htons(port);
  adress.sin_family = AF_INET;
  bcopy((char *)hp->h_addr,(char *)&adress.sin_addr,hp->h_length);
  longueur= sizeof(adress);
  printf(" Fin initialisation client\n");
  printf("** Client :: Client :initialisation terminee \n"); 
}

Client::Client() {
  // localisation de la machine distante
  printf("=====> entrez le nom de la machine distante: ");
  gets(hote);
  // Recuperation du pointeur sur structure hostent du serveur */
  if ((hp=gethostbyname(hote))==NULL) {
    perror(" nom de machine inconnu");
    exit(2);
  };
  // creation de la socket client 
  sock=socket(AF_INET,SOCK_STREAM,0);

  // initialisation de la stucture adress
  // Le port client est allou dynamaiquement par le systme et change  chaque
  // connexion (en mode no-connect)
  bzero((char * )&adress,sizeof(adress));
  adress.sin_port =htons(PORT); // port du serveur
  adress.sin_family = AF_INET;
  bcopy((char *)hp->h_addr,(char *)&adress.sin_addr,hp->h_length);
  longueur=sizeof(adress);

  if (connect(sock, (sockaddr*)&adress, longueur)==-1) {
    perror("connection failed : let try again !");
    exit(4);
  };

  printf("** Client :: Client :initialisation terminee \n");
}

int Client::send_mess(mess &msg) {
  int n;

  if (( n=write(sock,(char *)msg.trame(),msg.taille()))==-1) {
    perror("write");
    exit(2);
    return n;
  };
  printf("** Client :: send_mess : message envoye \n");
  return n;
}

int Client::recv_mess( mess &msg) {
  int n;
  char buffer[65536];

  if ((n=read(sock,buffer,256))==-1) {
    perror("read");
    exit(3);
    return n;
  };
  mess *msg_tmp = new mess((char *)buffer);
  msg = *msg_tmp;
  printf("** Client :: recv_mess : message recu \n");
 
  return n;
}

int Client::send_fic() {
  int n;
  fich* fichier = new fich;
  long t;
  char *name = new char[strlen(fichier->nom_fic())+1];
  strcpy(name, fichier->nom_fic());

  fichier->ouvrir_l();
  t = fichier->taille();

  if ((n = write(sock, name, (strlen(name)+1)*sizeof(char))) == -1) {
    perror("write : nom du fichier");
    exit(2);
    return n;
  };

  if ((n = write(sock, (char *)&t, sizeof(long))) == -1) {
    perror("write : taille du fichier");
    exit(2);
    return n;
  };

  long max = (long)((t-1)/MAX_INFO)+1;
  enreg *data = new enreg;
  int nb_item;
  fichier->deplace_deb(0);
  for (long i = 0; i<max; i++) {
	 nb_item = fichier->lire(data, MAX_INFO);
    if ((n = write(sock, data->info, nb_item*sizeof(char))) == -1) {
      perror("write");
      exit(2);
      return n;
    };
  };

  fichier->fermer();
  return n;
}

int Client::recv_fic() {
  int n;
  fich* fichier;
  long t;
  char *name = new char[MAX_NAME];

  if ((n = read(sock, name, MAX_NAME*sizeof(char))) == -1) {
    perror("read : nom du fichier");
    exit(2);
    return n;
  };

  if ((n = read(sock, (char *)&t, sizeof(long))) == -1) {
    perror("read : taille du fichier");
    exit(2);
    return n;
  };
  
  printf("Fichier : %s (%d o)\n", name, t);

  fichier = new fich(name);
  fichier->ouvrir_e();
  fichier->deplace_deb(0);

  long max = (long)((t-1)/MAX_INFO)+1;
  enreg *data = new enreg;
  for (long i = 0; i<max; i++) {
    if ((n = read(sock, data->info, MAX_INFO*sizeof(char))) == -1) {
      perror("read");
      exit(2);
      return n;
    };
	 fichier->ecrire(data, n);
  };

  fichier->fermer();
  return n;
}
