/*************************************************************************
 *
 *			Classe Serveur : FTP mode connecte
 *
 *			Implementation
 *
 * fichier Serv_FTP.C
 *************************************************************************/
 
#include <stdlib.h>
#include "Serv_FTP.h"
#include "fichier.h"

#define PORT 6002

Serveur::Serveur() {
  // creation et attachement d'une socket au port du service
  if ((sock = socket(AF_INET,SOCK_STREAM,0))==-1) {
    perror ("cration de socket impossible");
    exit(2);
  };
  bzero((char*)&adress,sizeof(adress));

  // initialisation de l'adresse
  port=PORT;
  adress.sin_port = htons(port);
  adress.sin_addr.s_addr = INADDR_ANY; // n'importe quelle adresse : la sienne
  adress.sin_family = AF_INET;

  // liaison de l'adresse avec le port du service */
  if (bind(sock, (sockaddr*)&adress, sizeof(adress))==-1) {
    perror("nommage de socket impossible");
    exit(3);
  };
  longueur=sizeof(adress);

  printf("** Serveur :: Serveur :initialisation terminee \n");

  listen(sock, 5);

  printf("Attente de connexion...\n");
  if((sock_cx=accept(sock, (sockaddr*)&addr_cln, &longueur_cln))==-1)
    {
      perror("accept");
      exit(4);
    };
  printf("Connexion etablie...\n");
}

int Serveur::send_mess(mess& msg) {
  int n;

  if (( n=write(sock_cx,(char *)msg.trame(),msg.taille()))==-1) {
    perror("write");
    exit(2);
    return n;
  };
  printf("** Serveur :: send_mess : message envoye \n");
  return n;
}

int Serveur::recv_mess(mess& msg) {
  int n;
  char buffer[65536];

  if((n=read(sock_cx,buffer,256))<=0) {
    perror("read");
    exit(3);
    return n;
  };
  mess *msg_tmp = new mess((char *)buffer);
  msg = *msg_tmp;
  printf("** Serveur :: recv_mess : message recu \n");
  
  return n;
}

int Serveur::send_fic() {
  int n;
  fich* fichier = new fich;
  long t;
  char *name = new char[strlen(fichier->nom_fic())+1];
  strcpy(name, fichier->nom_fic());

  fichier->ouvrir_l();
  t = fichier->taille();

  if ((n = write(sock_cx, name, (strlen(name)+1)*sizeof(char))) == -1) {
    perror("write : nom du fichier");
    exit(2);
    return n;
  };

  if ((n = write(sock_cx, (char *)&t, sizeof(long))) == -1) {
    perror("write : taille du fichier");
    exit(2);
    return n;
  };

  long max = (long)((t-1)/MAX_INFO)+1;
  enreg *data = new enreg;
  int nb_item;
  fichier->deplace_deb(0);
  for (long i = 0; i<max; i++) {
	 nb_item = fichier->lire(data, MAX_INFO);
    if ((n = write(sock_cx, data->info, nb_item*sizeof(char))) == -1) {
      perror("write");
      exit(2);
      return n;
    };
  };

  fichier->fermer();
  return n;
}

int Serveur::recv_fic() {
  int n;
  fich* fichier;
  long t;
  char *name = new char[MAX_NAME];

  if ((n = read(sock_cx, name, MAX_NAME*sizeof(char))) == -1) {
    perror("read : nom du fichier");
    exit(2);
    return n;
  };

  if ((n = read(sock_cx, (char *)&t, sizeof(long))) == -1) {
    perror("read : taille du fichier");
    exit(2);
    return n;
  };
  
  printf("Fichier : %s (%d o)\n", name, t);

  fichier = new fich(name);
  fichier->ouvrir_e();
  fichier->deplace_deb(0);

  long max = (long)((t-1)/MAX_INFO)+1;
  enreg *data = new enreg;
  for (long i = 0; i<max; i++) {
    if ((n = read(sock_cx, data->info, MAX_INFO*sizeof(char))) == -1) {
      perror("read");
      exit(2);
      return n;
    };
	 fichier->ecrire(data, n);
  };

  fichier->fermer();
  return n;
}
