/*************************************************************************
 *
 *			CLASSE CLIENT : mode non connecte
 *
 *			IMPLEMENTATION
 *
 * fichier client.C
 *************************************************************************/
  
#include "client.h"

#define PORT 6000
 
Client::Client(const char* hostname, int port) {
  // Recuperation du pointeur sur structure hostent du serveur */
  if ((hp=gethostbyname(hostname))==NULL) {
    perror(" nom de machine inconnu");
    exit(2);
  };
 
  // creation de la socket client 
  sock=socket(AF_INET,SOCK_DGRAM,0);  
 
  //  initialisation de la structure adress
  bzero((char * )&adress,sizeof(adress));  
  adress.sin_port =htons(port);
  adress.sin_family = AF_INET;           
  bcopy((char *)hp->h_addr,(char *)&adress.sin_addr,hp->h_length);
  longueur= sizeof(adress);
  printf(" Fin initialisation client\n");
  printf("** Client :: Client :initialisation terminee \n");
}
  
Client::Client() {
  // localisation de la machine distante
  printf("=====> entrez le nom de la machine distante: ");
  gets(hote);
  // Recuperation du pointeur sur structure hostent du serveur */
  if ((hp=gethostbyname(hote))==NULL) {
    perror(" nom de machine inconnu");
    exit(2);
  };
  // creation de la socket client 
  sock=socket(AF_INET,SOCK_DGRAM,0);  
 
  //  initialisation de la stucture adress
  // Le port client est allou dynamaiquement par le systme et change  chaque
  // connexion (en mode no-connect)
  bzero((char * )&adress,sizeof(adress));  
  adress.sin_port =htons(PORT); // port du serveur
  adress.sin_family = AF_INET;           
  bcopy((char *)hp->h_addr,(char *)&adress.sin_addr,hp->h_length);
  longueur=sizeof(adress);
  printf("** Client :: Client :initialisation terminee \n");
}

int Client::send_mess(mess &msg) {
  int n;

  if (( n=sendto(sock,(char *)msg.trame(),msg.taille(),0,&adress,longueur))==-1) {
    perror("sendto");
    printf("valeur de errno  %d\n", errno);
    exit(2);
  };
  printf("** Client :: send_mess : message envoye \n");
  return n;
}
 
int Client::recv_mess( mess &msg) {
  int n;
  if((n=recvfrom(sock,(char *)msg.trame(),msg.taille(),0,&adress,&longueur))==-1) {
    perror("recvfrom");
    printf("valeur de errno  %d\n", errno);
    exit(3);
  };
  printf("** Client :: recv_mess: message recu  \n");
  return n;
}
 
