/*************************************************************************
 *
 *			CLASSE FICHIER
 *
 *			IMPLEMENTATION
 *			
 ************************************************************************
 *
 * Implmentation des fonctions
 * 			fich (constructeur)
 *				~fich (destructeur)
 *  			ouvrir_l (en lecture)
 *				ouvrir_e (en ecriture, ajout)
 *				deplace_deb(en octets /debut de fichier)
 *				deplace_cur(/position courante)
 *				deplace_fin(/fin de fichier)
 *		      taille
 *          nom_fic
 *		      ecrire
 *				lire
 *
 * Utilisation des fonctions: fopen, fclose, fread, fwrite, fseek
 *	
 * Fichier fichier.C
 ***********************************************************************/

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include "inclu.h"
#include "fichier.h"

fich::fich() {
  int desc;
  printf ("Nom du fichier : ");
  scanf("%s",ficname);
  if ((fic = fopen(ficname,"r"))==NULL) {   // autorisation lecture
    desc = creat(ficname,00722);            // autorisation lecture-ecriture
    printf("fichier cree \n");
    if  (desc==-1)  {
      perror ("Erreur creation fichier");
    };
    fic= fdopen(desc,"w");
  };
  fclose(fic);
}

fich::fich(char *name) {
  int desc;
  strcpy(ficname, name);  
  if ((fic = fopen(ficname,"r"))==NULL) {   // autorisation lecture
    desc = creat(ficname,00722);            // autorisation lecture-ecriture
    printf("fichier cree \n");
    if  (desc==-1) {
      perror ("Erreur creation fichier");
    };
    fic= fdopen(desc,"w");
  };
  fclose(fic);
}

fich::~fich() {
  fclose(fic);
}

void fich::ouvrir_l() {
  fic = fopen(ficname,"r");           // autorisation lecture
  if (fic==NULL) {
    perror ("Erreur ouverture fichier");
  };
}

void fich::ouvrir_e() {
  fic = fopen(ficname,"a");           // autorisation ecriture
  if (fic==NULL) {
    perror ("Erreur ouverture fichier");
  };
}

void fich::fermer() {
  fclose(fic);
}

void fich::deplace_deb(int nb) {
  int ret;
  ret=fseek (fic,(long)nb*sizeof(enreg), SEEK_SET);
  if (ret!=0) perror ("deplacement fichier");
}

void fich::deplace_cur(int nb) {
  int ret;
  ret=fseek (fic, (long)nb*sizeof(enreg), SEEK_CUR);
  if (ret!=0) perror ("deplacement fichier");
};

void fich::deplace_fin(int nb) {
  int ret;
  ret= fseek (fic,(long)nb*sizeof(enreg), SEEK_END);
  if (ret!=0) perror ("deplacement fichier");
};

long fich::taille() {
  int ret = fseek (fic, 0, SEEK_END);
  if (ret!=0) perror ("taille fichier");
  return ftell(fic);
};

char* fich::nom_fic() {
  return ficname;
};

int fich::lire(enreg *rec, int t) {
  return fread(rec->info, sizeof(char), t, fic);
};

int  fich::ecrire(enreg *rec, int t) {
  return fwrite(rec->info, sizeof(char), t, fic);
};
